/* Programma che doverebbe verificare lo stato di una partita del gioco tictactoe.*/

/* 
   Il programma è costruito mediante tre funzioni che leggono i caratteri su ogni riga, colonna o diagonale. 
   Una quarta funzione viene chiamata per controllare se, su ognuna di esse, sono presenti quattro simboli 
   uguali, tenendo conto che il carattere 'T' vale come jolly.
   I controlli restituiscono valore 0 se l'esito è negativo.
   Viceversa, restituiscono 1 e stampano l'output se l'esito è positivo.
   A quel punto il programma termina.
   Con la stessa logica, una quinta funzione si incarica di verificare se siano ancora possibili mosse, solo nel caso in cui
   i controlli precedenti siano stati vani.
   Se anche quest'ultima evenienza non trova riscontro, la partita si è conclusa in parità.   
*/

/* 
   MANCA ACQUISIZIONE DATI: DEVO TROVARE I FILE DI INPUT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   Nondimeno, dovrebbero bastare una "fgetc" ed un ciclo nel main...
*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

int c_riga(char tabella[4][4]);              /* Controlla le righe */
int c_colonna(char tabella[4][4]);           /* Controlla le colonne */
int c_diagonale(char tabella[4][4]);         /* Controlla le diagonali */
int findwinner(int vet[4]);                  /* Controlla la presenza di un vincitore dato il numero di simboli */
int cercapunti(char tabella[4][4]);          /* Controlla la presenza di mosse possibili se non sono stati trovati vincitori */

int main(int argc, char *argv[])
{
	char tab[4][4]={{'X','T','0','X'}, {'0','0','0','X'}, {'X','0','X','0'}, {'0','T','0','0'}};  // prove a caso...
	int ris = 0;
	ris = c_riga(tab);
	if (ris == 0)
		ris = c_colonna(tab);
	if (ris == 0)
		ris = c_diagonale(tab);
	if (ris == 0)
		ris = cercapunti(tab);
	if (ris == 0)
		puts("Pareggio");        
	return 0;
}


/* Questa funzione scorre le righe e conta le ricorrenze di ciascun simbolo in ognuna di esse */
int c_riga(char tabella[4][4])
{
	/* Il vettore raccoglie il numero di simboli su ciascuna riga: num[0] sono le T
								       num[1] sono le X    
								       num[2] sono gli 0
								       num[3] sono i .	
	*/
	int num[4]={0};   
	int i=0, j=0, k=0;	
	int win=0;    /* Segnala se esiste un vincitore	*/
	char segno;	
	for(i=0; i<4; i++)
	{
		for(k=0; k<4; k++)     /* Reinizializzo il vettore a zero per un nuovo ciclo */
		{
			num[k]=0;
		}		
		for(j=0; j<4; j++)
		{
			segno=tabella[i][j];
			switch (segno)
			{
				case 'T': num[0]++; break;
				case 'X': num[1]++; break;
				case '0': num[2]++; break;
				case '.': num[3]++; break;
			}			
			if(j==3)
				win=findwinner(num);
			if(win!=0)              /* Se trovo il vincitore, perchè proseguire... */
				return win;
			//printf("ELEMENTO (%i, %i): %i, %i, %i, %i\n", i, j, num[0], num[1], num[2], num[3]);
		}
	}
	return win;            /* Se sono arrivato qui, win vale zero */
}



/* Ora la stessa cosa per le colonne */
int c_colonna(char tabella[4][4])
{
	int num[4]={0};   
	int i=0, j=0, k=0;	
	int win=0;    /* Segnala se esiste un vincitore	*/
	char segno;	
	for(j=0; j<4; j++)
	{
		for(k=0; k<4; k++)     /* Reinizializzo il vettore a zero per un nuovo ciclo */
		{
			num[k]=0;
		}	
		for(i=0; i<4; i++)
		{
			segno=tabella[i][j];
			switch (segno)
			{
				case 'T': num[0]++; break;
				case 'X': num[1]++; break;
				case '0': num[2]++; break;
				case '.': num[3]++; break;
			}			
			if(i==3)
				win=findwinner(num);
			if(win!=0)			/* Se trovo il vincitore, perchè proseguire... */
				return win;
			//printf("ELEMENTO (%i, %i): %i, %i, %i, %i\n", i, j, num[0], num[1], num[2], num[3]); 			
		}	
	}
	return win;     /* Se sono arrivato qui, win vale zero */
}


/* ...e per le diagnoali. Con qualche modifica.*/
int c_diagonale(char tabella[4][4])
{
	int num[4]={0};   
	int i=0, j=0, k=0;
	int win=0;    /* Segnala se esiste un vincitore	*/	
	char segno;	
	while(j<4 && i<4)           /* Per la diagonale principale */
	{
		segno=tabella[i][j];
		switch (segno)
		{
			case 'T': num[0]++; break;
			case 'X': num[1]++; break;
			case '0': num[2]++; break;
			case '.': num[3]++; break;
		}			
		if(i==3 && j==3)
			win = findwinner(num);
		if(win!=0)                    /* Se trovo il vincitore, perchè proseguire... */
			return win;
		//printf("ELEMENTO (%i, %i): %i, %i, %i, %i\n", i, j, num[0], num[1], num[2], num[3]);		
		i++;
		j++;
	}
	if (win==0)
	{
		i=0;             /* Reinizializzo per la diagonale secondaria */
		j=3;
		for(k=0; k<4; k++)     /* Reinizializzo il vettore a zero per un nuovo ciclo */
		{
			num[k]=0;
		}	
		while(i<4 && j>=0)
		{
			segno=tabella[i][j];
			switch (segno)
			{
				case 'T': num[0]++; break;
				case 'X': num[1]++; break;
				case '0': num[2]++; break;
				case '.': num[3]++; break;
			}			
			if(i==3 && j==0)
				win = findwinner(num);               /* Se trovo il vincitore, perchè proseguire... */
			if(win!=0)
				return win;                          
			//printf("ELEMENTO (%i, %i): %i, %i, %i, %i\n", i, j, num[0], num[1], num[2], num[3]);		
			i++;
			j--;
		}
	}
	return win;                       /* Se sono arrivato qui, win vale zero */
}
	
/* Infine la ricerca del vincitore e la stampa dei risultati */
int findwinner(int vet[4])
{
	/* Il vettore raccoglie il numero di simboli su ciascuna riga: vet[0] sono le T
								       vet[1] sono le X    
								       vet[2] sono gli 0
								       vet[3] sono i .	
	*/
	if(vet[0]+vet[1]==4)
	{
		puts("Il vincitore e': X");
		return 1;
	}
	if(vet[0]+vet[2]==4)
	{
		puts("Il vincitore e': 0");
		return 1;
	}
	return 0;            /* Significa che non ci sono vincitori */
}


/* La funzione che cerca possibili mosse */
int cercapunti(char tabella[4][4])
{
	int i=0, j=0;
	for(i=0; i<4; i++)
	{
		for(j=0; j<4; j++)
		{
			if(tabella[i][j]=='.')
			{	
				//printf("ELEMENTO (%i, %i): %c\n", i, j, tabella[i][j]);				
				puts("Nessun vincitore. Sono possibili ulteriori mosse.");
				return 1;
			}
		}
	}
	return 0;         /* Significa che non sono neppure possibili ulteriori mosse */
}


/*XTOX
OOOX
XOXX
OXOX*/
